Checks: '
bugprone-*,
performance-*,
modernize-*, -modernize-use-trailing-return-type,-modernize-avoid-c-arrays,-modernize-use-nodiscard,
concurrency-*,
readability-*,-readability-convert-member-functions-to-static,-readability-uppercase-literal-suffix,-readability-magic-numbers,

cppcoreguidelines-avoid-goto, cppcoreguidelines-slicing,cppcoreguidelines-pro-type-vararg, cppcoreguidelines-pro-type-cstyle-cast,
cppcoreguidelines-pro-type-member-init, cppcoreguidelines-prefer-member-initializer,
cppcoreguidelines-no-malloc, cppcoreguidelines-narrowing-conversions, cppcoreguidelines-init-variables,

cert-dcl21-cpp, # operator++ non-const return
cert-dcl50-cpp, # C-style variadic
cert-dcl58-cpp, # Change standard namespaces
cert-env33-c, # system calls
cert-err34-c, # string conversion missing check
cert-err52-cpp, # setjmp/longjmp
cert-msc50-cpp, # rand()
cert-msc51-cpp, # random seed
cert-oop58-cpp, # mutating copy

misc-definitions-in-headers,
misc-misplaced-const,
misc-no-recursion,
misc-non-copyable-objects, 
// misc-non-private-member-variables-in-classes,
misc-redundant-expression, 
misc-throw-by-value-catch-by-reference,
misc-unconventional-assign-operator,
misc-uniqueptr-reset-release,
misc-unused-alias-decls,
misc-unused-parameters,
misc-unused-using-decls,

google-readability-namespace-comments,
google-build-namespaces,
google-explicit-constructor,
google-global-names-in-headers,
google-readability-casting,

hicpp-exception-baseclass,

clang-analyzer-optin.performance.Padding,

'

CheckOptions:
  - { key: modernize-use-nullptr.NullMacros, value: NULL, }

  - { key: readability-identifier-naming.NamespaceCase,     value: lower_case  }
  - { key: readability-identifier-naming.ClassCase,     value: CamelCase  }
  - { key: readability-identifier-naming.VariableCase,  value: backCase }
  - { key: readability-identifier-naming.FunctionCase,  value: CamelCase }
  - { key: readability-identifier-naming.PrivateMemberPrefix,  value: m_ }
  - { key: readability-identifier-naming.ParameterCase, value: backCase }
  - { key: readability-identifier-naming.EnumCase, value: CamelCase }
  - { key: readability-identifier-naming.EnumIgnoredRegexp, value: Size_ }
  - { key: readability-identifier-naming.EnumConstantCase, value: CamelCase }
  - { key: readability-identifier-naming.EnumConstantIgnoredRegexp, value: Size_ }
  - { key: readability-identifier-naming.ScopedEnumCase, value: CamelCase }
  - { key: readability-identifier-naming.ScopedEnumConstantCase, value: CamelCase }
  - { key: readability-identifier-naming.TemplateParameterSuffix, value: _ }

  - { key: misc-non-private-member-variables-in-classes.IgnoreClassesWithAllMemberVariablesBeingPublic, value: True }
